#!/bin/sh

# Created by:
# Juhapekka Tolvanen
# http://iki.fi/juhtolv
# juhtolv (at) iki (dot) fi

# This script is public domain
# There is no warranty


ohshit()
{
    echo "Usage:" >&2
    echo "$1 (hostname) (remote home directory)" >&2
    echo "If path of remote home diretory is not used, we think that path is the same as path local home directory" | fmt >&2
    echo "Correct and retry." >&2
    exit 1
}

if test $# -lt 1
then
    ohshit
fi

if test $1 = ""
then
    ohshit
fi

REMOTEHOST="$1"

if test -z "$2" -o "$2" = ""
then
    REMOTEHOME="$HOME"
else
    REMOTEHOME="$2"
fi

echo REMOTEHOST=$REMOTEHOST
echo REMOTEHOME=$REMOTEHOME


if test -f ${HOME}/www/index.html
then
    :
else
    echo "WWW-directory seems bogus. Exiting..." >&2
    exit 1
fi


if ping -c 1 $REMOTEHOST
then
    :
else
    echo "Host called $1 do not exist or Internet is b0rken." >&2
    ohshit
fi


MYDATE="`date +%Y%m%d`"
MYDIR="/tmp"
PACKAGE="installshellrc"
DISTDIR="${PACKAGE}-${MYDATE}"

cd $MYDIR && rm -rf ./${PACKAGE}-*

# AFAIK star is faster and better than GNU tar
# http://www.fokus.gmd.de/research/cc/glone/employees/joerg.schilling/private/star.html

if star --version 2>&1 | grep -i "Schilling" > /dev/null 2>&1
then
    TAR_BIN='star'
    echo "Cool... You have star, not just GNU tar or plain tar"
elif gtar --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
then
    TAR_BIN="gtar"
    echo "Cool... You have GNU tar, not just plain tar"
elif tar --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
then
    TAR_BIN="tar"
    echo "Cool... You have GNU tar, not just plain tar"
fi

mkdir $DISTDIR || exit
cd $DISTDIR || exit 1

for F in README dot.zshrc.01.sh allshrc.01.sh dot.bashrc.01.sh
do
    scp ${REMOTEHOST}:${REMOTEHOME}/.newshellrc/${F} ./
done

scp ${REMOTEHOST}:${REMOTEHOME}/scripts/installshellrc ./
cp $0 ./

cd ..

cp ${0} ${DISTDIR}/

chmod -R ugo+rX ${DISTDIR}

$TAR_BIN  -c -f - ${DISTDIR} | bzip2 -9v >  ${PACKAGE}-${MYDATE}.tar.bz2

chmod ugo+r ${PACKAGE}-${MYDATE}.tar.bz2

/bin/mv -f ${PACKAGE}-${MYDATE}.tar.bz2 ${HOME}/www/hacks/sh/installshellrc/

cd  ${HOME}/www/hacks/sh/installshellrc/

chmod ugo+r,go-wx  ${PACKAGE}-${MYDATE}.tar.*
rm -f ${PACKAGE}-latest.tar.bz2
ln -sf ${PACKAGE}-${MYDATE}.tar.bz2 ${PACKAGE}-latest.tar.bz2 

rm -rf "${MYDIR}/${DISTDIR}"

echo "Package is:  ${HOME}/www/hacks/sh/installshellrc/${PACKAGE}-${MYDATE}.tar.bz2" | fmt
echo 'All done. Upload your WWW-pages.'





